<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER.tsx.ftl
</#ibizinclude>

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getDatas(): any[] {
        return this.items;
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getData(): any {
        return this.selection;
    }

    /**
     * 数据选中项
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public selection: any = {};

    /**
     * 父数据
     *
     * @private
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private parentData: any = {};

    /**
     * 关系栏数据项
     *
     * @type {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public items: any[] = [
        <#list ctrl.getRootItem().getAllItems() as dritem>
        {
            index: ${dritem_index?c}, 
            id: '${dritem.getId()?lower_case}',
            name: '${dritem.getId()?lower_case}', 
            text: '${dritem.text}', 
            disabled: false, 
        },
        </#list>
    ];

    /**
     * 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public created(): void {
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('state', action)) {
                    if (data.srfkey && !Object.is(data.srfkey, '')) {
                        Object.assign(this.parentData, { srfparentkey: data.srfkey });
                    }
                    const state = !this.parentData.srfparentkey || (this.parentData.srfparentkey && Object.is(this.parentData.srfparentkey, '')) ? true : false;
                    this.setItemDisabled(state);
                }
            });
        }
        this.$nextTick(() => {
            this.$emit('selectionchange', [this.items[0]]);
        });
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public destroyed() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 获取关系项
     *
     * @private
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private getDRTabItem(arg: any = {}): any {
        let expmode = arg.nodetype.toUpperCase();
        if (!expmode) {
            expmode = '';
        }
        <#list ctrl.getPSAppViewRefs() as item>
        <#if (item.getName()?index_of("DRITEM:")==0)>
        <#assign refview = item.getRefPSAppView()>
        if (Object.is(expmode, '${item.getName()?substring(7)}')) {
            return {  
                viewname: '${srffilepath2(refview.codeName)}', 
                parentdatajo: <#if item.getParentDataJO()??>${item.getParentDataJO()}<#else>{},</#if>
			};
        }
        </#if>
        </#list>
        return undefined;
    }

    /**
     * 设置关系项状态
     *
     * @param {boolean} state
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public setItemDisabled(state: boolean): void {
        this.items.forEach((item: any) => {
            if (Object.is(item.name, 'form')) {
                item.disabled = false;
            } else {
                item.disabled = state;
            }
        });
    }

    /**
     * 获取数据项
     *
     * @private
     * @param {string} id
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private getItem(id: string): any {
        const arr: any[] = this.items.filter((_item: any) => Object.is(_item.id, id));
        if (arr) {
            return arr[0];
        }
        return null;
    }

    /**
     * 选中节点
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public tabPanelClick($event: any): void {
        const item = this.getItem($event);
        if (Object.is(item.id, this.selection.id)) {
            return;
        }
        this.$emit('selectionchange', [item]);

        const refview = this.getDRTabItem({ nodetype: item.id });
        this.selection = {};
        const params: any = { ...JSON.parse(JSON.stringify(this.parentData)) };
        if (refview && refview.parentdatajo) {
            Object.assign(params, refview.parentdatajo);
            Object.assign(this.selection, { view: { viewname: refview.viewname }, data: params });
        }
        Object.assign(this.selection, item);
    }
<#-- 定义宏 -->
<#macro getParentmode PSDEDataRelation dritemName>
    <#compress>
    <#if PSDEDataRelation.getPSDEDRDetails?? && PSDEDataRelation.getPSDEDRDetails()??>
    <#assign deDrDetails = PSDEDataRelation.getPSDEDRDetails() />
	<#list deDrDetails as deDrDetail>
    <#if deDrDetail.getName() == dritemName && deDrDetail.getPSDEDRItem?? &&  deDrDetail.getPSDEDRItem()?? && deDrDetail.getPSDEDRItem().getParentDataJO()??>
    ${deDrDetail.getPSDEDRItem().getParentDataJO()}
    </#if>
    </#list>
    </#if>
    </#compress>
</#macro>


<#list ctrl.getRootItem().getAllItems() as dritem>

    /**
     * 绘制 ${dritem.text} 分页
     *
     * @param {string} id
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public render_${dritem.getId()?lower_case}(id: string) {
        const arr: any[] = this.items.filter((_item: any) => Object.is(_item.id, id));
        const [item] = arr;
        return (
            <tab-pane index={item.index} name={item.name} tab={this.name} class='' disabled={item.disabled}
                label={
                    (h: any) => {
                        return (
                            <span class='caption'>
                                {item.text}
                            </span>
                        );
                    }
                }>
                <#if dritem.getId()?lower_case == 'form'>
                <div class='main-data'>
                    {this.$slots.default}
                </div>
                <#else>
                {
                    (
                        Object.is(this.selection.id, '${dritem.getId()?lower_case}') &&
                        this.selection.view &&
                        !Object.is(this.selection.view.viewname, '')
                    ) ?
                        this.$createElement(this.selection.view.viewname, {
                            class: {
                                viewcontainer2: true,
                            },
                            props: {
                                viewdata: JSON.stringify({ srfparentdata: Object.assign(this.selection.data,<@getParentmode ctrl.getPSDEDataRelation() '${dritem.getId()}'/>)}),
                            },
                            key: this.$util.createUUID(),
                        })
                        : ''
                }
                </#if>
            </tab-pane>
        );
    }
</#list>

    /**
     * 绘制内容
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public render() {
        return (
            <tabs animated={false} class='app-dr-tab' name={this.name} on-on-click={($event: any) => this.tabPanelClick($event)}>
                <#list ctrl.getRootItem().getAllItems() as dritem>
                {this.render_${dritem.getId()?lower_case}('${dritem.getId()?lower_case}')}
                </#list>
            </tabs>
        );
    }

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM.tsx.ftl
</#ibizinclude>
